package japflash;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Vector;
import java.util.Random;
/**
 * Title:        JapFlash
 * Copyright:
 * Parts of this program (Japanese Bitmap Font support) are taken
 * from KanjiFlash by Marshall Ramsey
 * This program is the copyright of Alexander Bergner, however, you have
 * permission to use the source code as long as the programs you create
 * will be made available without charge and you include the programs'
 * source code and credit is given to me and Marshall Ramsey for providing
 * the code you use.
 * You may distribute this program as long as all the files are included
 * in the distribution and it is provided free of charge or for a small
 * materials fee.
 * @author insaneLX
 * @version 1.0
 */

class CardStack {
  Vector pile[];
  private Random r = new Random();

  public CardStack(int piles) {
    pile = new Vector[piles];
    for (int i = 0;  i < pile.length; i++) {
      pile[i]= new Vector();
    }
  }

  boolean isEmpty() {
    for (int i = 0; i< pile.length; i++) {
      if (!pile[i].isEmpty()){ return false;}
    }
    return true;
  }

  public void clearStack(){
    for (int i = 0; i< pile.length; i++) {
      pile[i].removeAllElements();
    }
  }

  FlashCard liftCardFromPile(int p){  // lifts a card from pile p,pos
    try {
      int i =(int)((float)(pile[p].size()-1)*r.nextFloat());
      FlashCard fC = (FlashCard)pile[p].elementAt(i);
      pile[p].removeElementAt(i);
      return  fC;
    } catch (IndexOutOfBoundsException e ) {
      return null;
    }
  }

  void putCardToPile(FlashCard fc,int p){         // puts card on top of pile p
    pile[p].insertElementAt(fc,0);
  }
}

