package japflash;

import java.awt.Font;
import java.awt.Color;
import java.awt.Label;
import java.io.*;
import java.util.Properties;
import tools.FieldInitialiser;
import tools.LXToolBox;

/**
 * Title:        JapFlash
 * Copyright:
 * Parts of this program (Japanese Bitmap Font support) are taken
 * from KanjiFlash by Marshall Ramsey
 * This program is the copyright of Alexander Bergner, however, you have
 * permission to use the source code as long as the programs you create
 * will be made available without charge and you include the programs'
 * source code and credit is given to me and Marshall Ramsey for providing
 * the code you use.
 * You may distribute this program as long as all the files are included
 * in the distribution and it is provided free of charge or for a small
 * materials fee.
 * @author insaneLX
 * @version 1.0
 */


public class Options implements Serializable {
  public boolean isDefault;
  public int testMode;
  int liftStrategy;
  public boolean loadLastFileAtStartup;
  public String fileName;
  public String directoryList;
  public String bitmapFontFileName;
  public String backgroundImageFileName;
  int piles;
  public float liftProbabilityFactor;
  public int defaultScreenWidth;
  public int defaultScreenHeight;
  int cardInsetsH;
  int cardInsetTop;
  int cardInsetBottom;
  public String kanjiFontName;
  int kanjiFontStyle;
  public int kanjiFontSize;
  public String readingFontName;
  int readingFontStyle;
  public int readingFontSize;
  public String meaningFontName;
  int meaningFontStyle;
  public int meaningFontSize;
  int textPadding;

  public Color backgroundColor;
  public Color stackStartColor;
  public Color stackEndColor;
  public Color stackBackgroundStartColor;
  public Color stackBackgroundEndColor;

  Color fCFillColor;
  Color fCRightFillColor;
  Color fCWrongFillColor;
  Color fCBorderColor;
  Color darkLineColor;
  Color lightLineColor;
  int animationFrames;
  int showHideAnimTime;
  int flashAnimTime;
  static String frameTitle = "Japflash";
  private Label messageLabel;
  String iniFileHeader = "JapFlash by insaneLX";

  public Options() {
    isDefault = true;
    testMode = FlashCardPrinter.KANJITOENG;
    liftStrategy = StackPanel.STANDARD;
    loadLastFileAtStartup = true;
    fileName = "";
    bitmapFontFileName = "k16x16.gz";
//    bitmapFontFileName = null;
    directoryList = "C#C:/Eigene Dateien/MNGU-UTF8/|E#E:/";
    backgroundImageFileName = "";
    piles = 5;
    liftProbabilityFactor = 1.5f;
    defaultScreenWidth = 240;
    defaultScreenHeight = 300;
    cardInsetsH = 10;
    cardInsetTop = 10;
    cardInsetBottom = 20;
    kanjiFontName = "Dialog";
    kanjiFontStyle = Font.PLAIN;
    kanjiFontSize = 32;
    readingFontName = "Dialog";
    readingFontStyle =  Font.PLAIN;
    readingFontSize = 16;
    meaningFontName = "Dialog";
    meaningFontStyle =  Font.PLAIN;
    meaningFontSize = 16;
    textPadding = 5;

    backgroundColor = new Color(0.9f,0.96f,1f);
    stackStartColor = new Color(0.3f,1f,0.3f);;
    stackEndColor = new Color(1f,0.3f,0.3f);;
    stackBackgroundStartColor = new Color(0.9f,1f,0.9f);;
    stackBackgroundEndColor = new Color(1f,0.9f,0.9f);;
    fCFillColor = new Color(0.95f,0.95f,0.6f);
    fCRightFillColor   = new Color(0.85f,0.95f,0.7f);
    fCWrongFillColor   = new Color(0.95f,0.85f,0.7f);
    fCBorderColor = Color.black;
    darkLineColor = new Color(0.8f,0.8f,0.6f);
    lightLineColor = new Color(0.9f,0.9f,0.6f);
    animationFrames = 3;
    showHideAnimTime = 30;
    flashAnimTime = 500;
    LXToolBox.debugMessage("init default");
  }
}

