package japflash;

import java.awt.*;
import java.awt.event.*;
/**
 * Title:        JapFlash
 * Copyright:
 * Parts of this program (Japanese Bitmap Font support) are taken
 * from KanjiFlash by Marshall Ramsey
 * This program is the copyright of Alexander Bergner, however, you have
 * permission to use the source code as long as the programs you create
 * will be made available without charge and you include the programs'
 * source code and credit is given to me and Marshall Ramsey for providing
 * the code you use.
 * You may distribute this program as long as all the files are included
 * in the distribution and it is provided free of charge or for a small
 * materials fee.
 * @author insaneLX
 * @version 1.0
 */


public class YesNoCancelDialog extends Dialog implements WindowListener {
  Panel buttonPanel = new Panel();
  Button yesButton = new Button("Yes");
  Button noButton = new Button("No");
  Button cancelButton = new Button("Cancel");
  int result;
  final static int YES = 1;
  final static int CANCEL = 2;
  final static int NO = 3;
  Frame owner;

  public YesNoCancelDialog(Frame ow,String title,String question, String oKLabel,
                        String NoLabel,String cancelLabel) {
    super(ow,title);
    owner = ow;
    addWindowListener(this);
    setLayout(new BorderLayout());
    setSize(220,100);
    setModal(true);
    buttonPanel.add(yesButton);
    buttonPanel.add(noButton);
    buttonPanel.add(cancelButton);
    add(buttonPanel,BorderLayout.SOUTH);
    add(new Label(question,Label.CENTER),
        BorderLayout.CENTER);
    noButton.addActionListener(
      new ActionListener(){
        public void actionPerformed(ActionEvent e) {close(NO);}
      }
    );
    cancelButton.addActionListener(
      new ActionListener(){
        public void actionPerformed(ActionEvent e) {close(CANCEL);}
      }
    );
    yesButton.addActionListener(
      new ActionListener(){
        public void actionPerformed(ActionEvent e) {close(YES);}
      }
    );
  }


  void close(int r) {
    result = r;
    setVisible(false);
  }

  public void windowClosing(WindowEvent e) {close(CANCEL);}
  public void windowClosed(WindowEvent e) {}
  public void windowDeactivated(WindowEvent e) {}
  public void windowActivated(WindowEvent e) {}
  public void windowDeiconified(WindowEvent e) {}
  public void windowIconified(WindowEvent e) {}
  public void windowOpened(WindowEvent e) {
    setLocation(owner.getLocationOnScreen().x+10,owner.getLocationOnScreen().y+40);
  }

}