package japsupport;
/**
 * Title:        JapFlash
 * Copyright:
 * Parts of this program (Japanese Bitmap Font support) are taken
 * from KanjiFlash by Marshall Ramsey
 * This program is the copyright of Alexander Bergner, however, you have
 * permission to use the source code as long as the programs you create
 * will be made available without charge and you include the programs'
 * source code and credit is given to me and Marshall Ramsey for providing
 * the code you use.
 * You may distribute this program as long as all the files are included
 * in the distribution and it is provided free of charge or for a small
 * materials fee.
 * @author insaneLX
 * @version 1.0
 */

/* This code is copyrighted (c) 1997 by Marshall Ramsey */
import java.awt.*;

public class FontCanvas extends TextCanvas {
  int maxSize;

  public FontCanvas() {
    super();
    maxSize = DEFAULT_MAXSIZE;
  }

  public FontCanvas(int justify) {
    super(justify);
    maxSize = DEFAULT_MAXSIZE;
  }

  public FontCanvas(int justify, int maxSize) {
    super(justify);
    if (maxSize != 0)
      this.maxSize = maxSize;
    else
      this.maxSize = DEFAULT_MAXSIZE;
  }

  public void setMaxSize(int maxSize) { this.maxSize = maxSize; repaint(); }

  public void paint(Graphics g) {
    Dimension d = getSize();

    if (showing) {
      //draw string
      Font f = getFont();
      String fontName = f.getName();
      int fontStyle = f.getStyle();
      int fontSize = f.getSize();
      if (fontSize != maxSize) {
	fontSize = maxSize;
	f = new Font(fontName, fontStyle, fontSize);
	g.setFont(f);
      }
      FontMetrics fm = getFontMetrics(f);
      int h = fm.getHeight();
      int w = fm.stringWidth(text);
      while((h > d.height || w > d.width) && fontSize != 10) {
	fontSize-=12;
        fontSize = fontSize > 9 ? fontSize : 10;
        f = new Font(fontName, fontStyle, fontSize);
        fm = getFontMetrics(f);
        h = fm.getHeight();
        w = fm.stringWidth(text);
      }
      g.setFont(f);
      if (justify == CENTER)
	g.drawString(text, d.width/2 - w/2, d.height/2 + h/3);
      else if (justify == LEFT)
	g.drawString(text, 2, d.height/2 + h/3);
      else //RIGHT
	g.drawString(text, d.width - w - 2, d.height/2 + h/3);
    }
    else {
      g.setColor(Color.lightGray);
      g.fillRect(0, 0, d.width-1, d.height-1);
    }

    // paint border
    super.paint(g);
  }
}


